/* GCC */
#include <iostream>
#include <vector>
#include <set>
#include <math.h>


#define mp make_pair
#define x first
#define y second

using namespace std;



int d;

struct pnt {
       int x; int y;
       
       pnt(){}
       pnt(int _x, int _y) { x = _x; y = _y; }
       
       };
       
struct pt {
       int x; int y; int z;
       
       pt(){}
       pt(int _x, int _y,int _z) { x = _x; y = _y; z = _z;}
       };
       
bool operator == (pt a, pt b) {
     return (a.x == b.x && a.y == b.y && a.z == b.z);
     
     }       
       
bool operator < (pnt a, pnt b) {
     
     if (a.x ==b.x) return a.y <=b.y;
     return a.x < b.x;
     
     }       
typedef set <pnt> :: iterator sit;

set < pnt > xy0,xyd, yz0,yzd, xz0, xzd;


long long _sqr( set <pnt> &t,bool isMin = 1) {
             
             int res = 0;
             sit q = t.begin();
             sit i = t.begin();
             i++; 
      for (; i !=t.end(); i++,q++) {
          res += abs( (*i).x* (*q).y - (*i).y*(*q).x);
          
          
          }       
    if (isMin) return res;
    return 2*d*d-res;
    
}

long long sqr (int a, bool isMin) {
     
     switch(a) {
               case 0: return _sqr (xy0,isMin);
               case 1: return _sqr (xyd,isMin);
               case 2: return _sqr (yz0,isMin);
               case 3: return _sqr (yzd,isMin);
               case 4: return _sqr (xz0,isMin);
               case 5: return _sqr (xzd,isMin);
               
               }
     
     
     }

vector < bool > used(6,0);

vector < pt > minlink(6, pt (-1,-1,-1));

pt _pt (int w, int q) {
       
       switch (w) {
              case 0: 
                   if ( q == 0) return pt(0,0,0);
                   if ( q == 1) return pt(0,d,0);
                   if ( q == 2) return pt(d,d,0);
                   if ( q == 3) return pt(d,0,0);
                   break;
                   
                   
              case 1: 
                   if ( q == 0) return pt(0,0,d);
                   if ( q == 1) return pt(0,d,d);
                   if ( q == 2) return pt(d,d,d);
                   if ( q == 3) return pt(d,0,d);
                   break;
                   
                   
              case 2: 
                   if ( q == 0) return pt(0,0,0);
                   if ( q == 1) return pt(0,0,d);
                   if ( q == 2) return pt(0,d,d);
                   if ( q == 3) return pt(0,d,0);
                   break;
                   
                   
              case 3: 
                   if ( q == 0) return pt(d,0,0);
                   if ( q == 1) return pt(d,0,d);
                   if ( q == 2) return pt(d,d,d);
                   if ( q == 3) return pt(d,d,0);
                   break;
              
              case 4: 
                   if ( q == 0) return pt(0,0,0);
                   if ( q == 1) return pt(0,0,d);
                   if ( q == 2) return pt(d,0,d);
                   if ( q == 3) return pt(d,0,0);
                   break;
                   
              case 5: 
                   if ( q == 0) return pt(0,d,0);
                   if ( q == 1) return pt(0,d,d);
                   if ( q == 2) return pt(d,d,d);
                   if ( q == 3) return pt(d,d,0);
                   break;
              
              }
       
       }

void add (int x,int y, int z) {
     
     if (z == 0) xy0.insert( pnt ( x, y ) ),used[0]=1;
     if (z == d) xyd.insert( pnt ( x, y ) ),used[1]=1;
     
     if (x == 0) yz0.insert( pnt ( y, z ) ),used[2]=1;
     if (x == d) yzd.insert( pnt ( y, z ) ),used[3]=1;
     
     if (y == 0) xz0.insert( pnt ( x, z ) ),used[4]=1;
     if (y == d) xzd.insert( pnt ( x, z ) ),used[5]=1;
     
     
     }

void invset ( set < pnt > &t, int w) {
     if (!used[w]) return;
     
     set < pnt > res;
     sit q = t.begin();
     sit i = t.begin();
     i++; 
     for (; i !=t.end(); i++,q++) {
     }
     i = t.begin();
     if ((*i).x == 0 && (*q).y == 0) {minlink[w] = _pt(w,0); return;}
     
     if ((*i).x == 0 && (*q).y == d) {minlink[w] = _pt(w,1); for (sit r= t.begin(); r !=t.end(); r++) res.insert(pnt((*r).x,d-(*r).y)); t = res; return;}
     
     if ((*i).x == d && (*q).y == d) {minlink[w] = _pt(w,2); for (sit r= t.begin(); r !=t.end(); r++) res.insert(pnt(d-(*r).x,d-(*r).y));t = res;  return;}
 
     if ((*i).x == d && (*q).y == 0) {minlink[w] = _pt(w,3); for (sit r= t.begin(); r !=t.end(); r++) res.insert(pnt((*r).x,d-(*r).y));t = res;  return;}
     
     if ((*i).x == 0 && (*q).x == d) {minlink[w] = _pt(w,0); t.insert( pnt (d,0) ); return;}
     
     if ((*i).y == 0 && (*q).y == d) {minlink[w] = _pt(w,0); t.insert( pnt (0,d) ); return;}
     
     if ((*i).y == d && (*q).y == 0) {minlink[w] = _pt(w,0); t.insert( pnt (0,d) ); return;}
    
     
}


 long long res1=0,res2=0;
 
 bool consist (pt t, int w) {
     int x = t.x, y = t.y, z= t.z;
     if (z == 0 && w == 0) return 1;
     if (z == d && w == 1) return 1;
     
     if (x == 0 && w == 2) return 1;
     if (x == d && w == 3) return 1;
     
     if (y == 0 && w == 4) return 1;
     if (y == d && w == 5) return 1;
     
     return 0;
     }
 
 
void result() { 
      long long res = 0;
      vector < char > was(6,0);
      int st = 0;
      for (int i = 0; i < 6; i++) {
          if (used[i]) { st = i; break;}
          
          }
      
      bool isMin = 1;
            int q;
      while (1) {
            was[st]=1;      
            res += sqr(st, isMin);
            
            
            for (q=0;q < 6;q++) {
                if (used[q] && (!was[q]) && consist(minlink[st],q) ){
                            if (! (minlink[st] == minlink[q]) ) isMin = 0;
                            st = q;
                            
                            goto endfor;
                            }
                }
                endfor:
            if (q ==6) goto end;
            }
      
      
      end:
          res1 = res;
          res2 = 12*d*d - res1;
          cout << min(res1,res2) << " " << max(res1,res2) << endl;
      
      }


int main() {
  
  freopen("cubesurf.in","r",stdin);
  freopen("cubesurf.out","w",stdout);  
  
  cin >> d;  
  int n;
  cin >> n;
  int x,y,z;
  for (int i = 0; i < n; i++) {
      
      scanf("%d%d%d",&x,&y,&z);
      add(x,y,z);     
      }
 
 
 invset(xy0,0);
 invset(xyd,1);
 invset(yz0,2);
 invset(yzd,3);
 invset(xz0,4);
 invset(xzd,5);
 
 
 result();
 
 fclose(stdin);
 fclose(stdout);   
}
