/* GCC */
#include <fstream>
#include <vector>
#include <map>
#include <utility>
#include <algorithm>
int main(void)
{
    size_t n = 0;
    size_t maxCount = 1;
    std::ifstream in("sequence.in");
    in >> n;
    size_t* elems2 = new size_t[n];
    for(size_t i = 0; i < n; i++)
               in >> elems2[i];
    in.close();
    std::map<size_t, std::map<size_t, std::pair<size_t, size_t> > > res;// first = difference!!
    std::map<size_t, size_t> res_diff0;
    for(size_t i = 0; i < n; i++)
    {
        res_diff0[elems2[i]]++;
        if(maxCount < res_diff0[elems2[i]])
            maxCount++;
    }
    std::vector<size_t> elems;
    for(size_t i = 0; i < n; i++)
    {
        if(std::find(elems.begin(), elems.end(), elems2[i]) == elems.end())
           elems.push_back(elems2[i]);
    }
    delete[] elems2;
    n = elems.size();
    for(size_t i = 0; i < n-1; i++)
    {
               for(size_t j = i+1; j < n; j++)
               {
                    size_t minn = std::min(elems[i], elems[j]);
                    size_t maxx = std::max(elems[i], elems[j]);
                    size_t diff = maxx - minn;
                    if(diff > 0)
                    {
                        size_t o = elems[i]%diff;
                        res[diff][o].first++;
                        if(res[diff][o].second == 0 || minn < res[diff][o].second)
                            res[diff][o].second = minn;
                        if(maxCount-1 < res[diff][o].first)
                            maxCount++;
                    }
               }
    }
    std::ofstream out("sequence.out");
    std::vector<std::pair<size_t, size_t> > outRes;
    for(std::map<size_t, std::map<size_t, std::pair<size_t, size_t> > >::iterator i = res.begin(); i != res.end(); i++)
        for(std::map<size_t, std::pair<size_t, size_t> >::iterator j = i->second.begin(); j != i->second.end(); j++)
            if(j->second.first == maxCount-1)
                outRes.push_back(std::make_pair(j->second.second, i->first));
    for(std::map<size_t, size_t>::iterator i = res_diff0.begin(); i != res_diff0.end(); i++)
        if(i->second == maxCount)
            outRes.push_back(std::make_pair(i->first, 0));
    std::sort(outRes.begin(), outRes.end());
    for(size_t i = 0; i < outRes.size(); i++)
        out << maxCount << ' ' << outRes[i].first << ' ' << outRes[i].second << '\n';
    out.close();
    return 0;
}
