/* GCC */
#include <set>
#include <list>
#include <math.h>
#include <vector>
#include <iostream>
#include <algorithm>

#define F first
#define S second
#define pb push_back
#define mp make_pair
#define FOR(i,a,b) for( int i = (a), _n_ = (b); i <= _n_; i++ )
#define FORD(i,a,b) for( int i = (a), _n_ = (b); i >= _n_; i-- )
#define forn(i,n) FOR(i,0,(n) - 1)
#define ll long long
#define ull unsigned long long

using namespace std;

struct point3D {
       ull x, y, z;
       point3D(){}
       point3D( ull x, ull y, ull z ): x(x), y(y), z(z) {}
};

struct point2D {
       ull x, y;
       point2D(){}
       point2D( ull x, ull y ): x(x), y(y) {}
};

ull S( list<point2D>& ls ) {
    ll ans = 0;
    
    for( list<point2D>::iterator itn = ls.begin(), it = itn++; it != ls.end(); it++, itn++, (itn == ls.end())? itn = ls.begin(): itn = itn ) {
         ans += (itn->x - it->x)*( min( it->y, itn->y ) + max( it->y, itn->y ) );
    }
    
    return abs( ans );
}

list< point2D > ls;

int main() {
    freopen("cubesurf.in", "r", stdin);
    freopen("cubesurf.out", "w", stdout);
    
    int n;
    ull x, y, z, d;
    cin >> d >> n;
    forn( i, n ) {
          cin >> x >> y >> z;
          if( x == d ) {
              ls.pb( point2D( y + d, z + d ) );
          } else {
                 if( y == 0 ) {
                     ls.pb( point2D( x, z ) );
                 } else {
                        if( y == d ) {
                            ls.pb( point2D( 3 * d - x, z ) );
                        } else {
                               if( z == 0 ) {
                                   ls.pb( point2D( y + d, x ) );
                               } else {
                                      if( z == d ) {
                                          ls.pb( point2D( y + d, 3*d - x ) );
                                      } else ls.pb( point2D( y + d, 4 * d - z ) );
                               }
                        }
                 }
          }
    }
    
    ull s1 = S(ls);
    cout << min( (ull)s1, (ull)d * d * 12 - s1 ) << " " << max( (ull)s1, (ull)d * d * 12 - s1 ) << endl;
    
    fclose(stdout);
    fclose(stdin);
    return 0;
}
